import Component from '@glimmer/component';
import { SummarySignature } from '../../../../interfaces/components/models-table/themes/default/summary-signature.interface';
/**
 * Summary block used within {@link DefaultTheme.Footer}.
 *
 * Usage example:
 *
 * ```html
 * <ModelsTable @data={{this.data}} @columns={{this.columns}} as |MT|>
 *   <MT.Footer as |Footer|>
 *     <Footer.Summary />
 *     {{! ... }}
 *   </MT.Footer>
 *   {{! .... }}
 * </ModelsTable>
 * ```
 *
 * References to the following properties are yielded:
 *
 * * {@link summary} - message like "Show xx - yy from zzz"
 */
export default class Summary extends Component<SummarySignature> {
    protected elementId: string;
    protected get paginationTypeClass(): string;
    /**
     * Summary message like `A - B of C`
     */
    get summary(): string;
    protected get inputId(): string;
    /**
     * @event doClearFilters
     */
    protected doClearFilters(e: Event): void;
    /**
     * @event noop
     */
    protected noop(): void;
}
//# sourceMappingURL=summary.d.ts.map