import ModelsTableColumn from 'ember-models-table/utils/emt/emt-column';
import DefaultTheme from 'ember-models-table/services/emt-themes/default';
import { ModelsTableDataItem } from 'ember-models-table/types/models-table-data-item.type';
import { ColumnComponents } from 'ember-models-table/interfaces/column-components.interface';
import { RowInteractionClb } from 'ember-models-table/types/row-interaction-clb.type';
export interface TableFooterArgs {
    /**
     * Bound from {@link DefaultTheme.TableArgs.visibleProcessedColumns | TableArgs.visibleProcessedColumns}
     */
    visibleProcessedColumns: ModelsTableColumn[];
    /**
     * Bound from {@link DefaultTheme.TableArgs.displayGroupedValueAs | TableArgs.displayGroupedValueAs}
     */
    displayGroupedValueAs: string;
    /**
     * Bound from {@link DefaultTheme.TableArgs.useDataGrouping | TableArgs.useDataGrouping}
     */
    useDataGrouping: boolean;
    /**
     * Bound from {@link DefaultTheme.TableArgs.themeInstance | TableArgs.themeInstance}
     */
    themeInstance: DefaultTheme;
    /**
     * Bound from {@link DefaultTheme.TableArgs.data | TableArgs.data}
     */
    data: ModelsTableDataItem[];
    /**
     * Bound from {@link DefaultTheme.TableArgs.columnComponents | TableArgs.columnComponents}
     */
    columnComponents?: ColumnComponents;
    /**
     * Bound from {@link DefaultTheme.TableArgs.selectedItems | TableArgs.selectedItems}
     */
    selectedItems: ModelsTableDataItem[];
    /**
     * Bound from {@link DefaultTheme.TableArgs.expandedItems | TableArgs.expandedItems}
     */
    expandedItems: ModelsTableDataItem[];
    /**
     * Bound from {@link DefaultTheme.TableArgs.expandRow | TableArgs.expandRow}
     *
     * @event expandRow
     */
    expandRow: RowInteractionClb;
    /**
     * Bound from {@link DefaultTheme.TableArgs.collapseRow | TableArgs.collapseRow}
     *
     * @event collapseRow
     */
    collapseRow: RowInteractionClb;
    /**
     * Bound from {@link DefaultTheme.TableArgs.expandAllRows | TableArgs.expandAllRows}
     *
     * @event expandAllRows
     */
    expandAllRows: () => void;
    /**
     * Bound from {@link DefaultTheme.TableArgs.collapseAllRows | TableArgs.collapseAllRows}
     *
     * @event collapseAllRows
     */
    collapseAllRows: () => void;
}
//# sourceMappingURL=table-footer-args.interface.d.ts.map