import { ComponentLike } from '@glint/template';
import Service from '@ember/service';
import { CellSignature } from '../../interfaces/components/models-table/themes/default/cell-signature.interface';
import { CellContentDisplaySignature } from '../../interfaces/components/models-table/themes/default/cell-content-display-signature.interface';
import { CellContentEditSignature } from '../../interfaces/components/models-table/themes/default/cell-content-edit-signature.interface';
import { CellEditToggleSignature } from '../../interfaces/components/models-table/themes/default/cell-edit-toggle-signature.interface';
import { CellColumnSummarySignature } from '../../interfaces/components/models-table/themes/default/cell-column-summary-signature.interface';
import { ColumnsDropdownSignature } from '../../interfaces/components/models-table/themes/default/columns-dropdown-signature.interface';
import { ColumnsHiddenSignature } from '../../interfaces/components/models-table/themes/default/columns-hidden-signature.interface';
import { DataGroupBySelectSignature } from '../../interfaces/components/models-table/themes/default/data-group-by-select-signature.interface';
import { ExpandAllToggleSignature } from '../../interfaces/components/models-table/themes/default/expand-all-toggle-signature.interface';
import { ExpandToggleSignature } from '../../interfaces/components/models-table/themes/default/expand-toggle-signature.interface';
import { FooterSignature } from '../../interfaces/components/models-table/themes/default/footer-signature.interface';
import { GlobalFilterSignature } from '../../interfaces/components/models-table/themes/default/global-filter-signature.interface';
import { GroupedHeaderSignature } from '../../interfaces/components/models-table/themes/default/grouped-header-signature.interface';
import { NoDataSignature } from '../../interfaces/components/models-table/themes/default/no-data-signature.interface';
import { PageSizeSelectSignature } from '../../interfaces/components/models-table/themes/default/page-size-select-signature.interface';
import { PaginationNumericSignature } from '../../interfaces/components/models-table/themes/default/pagination-numeric-signature.interface';
import { PaginationSimpleSignature } from '../../interfaces/components/models-table/themes/default/pagination-simple-signature.interface';
import { RowSignature } from '../../interfaces/components/models-table/themes/default/row-signature.interface';
import { RowExpandSignature } from '../../interfaces/components/models-table/themes/default/row-expand-signature.interface';
import { RowFilteringSignature } from '../../interfaces/components/models-table/themes/default/row-filtering-signature.interface';
import { RowFilteringCellSignature } from '../../interfaces/components/models-table/themes/default/row-filtering-cell-signature.interface';
import { RowGroupingSignature } from '../../interfaces/components/models-table/themes/default/row-grouping-signature.interface';
import { RowGroupToggleSignature } from '../../interfaces/components/models-table/themes/default/row-group-toggle-signature.interface';
import { RowSelectAllCheckboxSignature } from '../../interfaces/components/models-table/themes/default/row-select-all-checkbox-signature.interface';
import { RowSelectCheckboxSignature } from '../../interfaces/components/models-table/themes/default/row-select-checkbox-signature.interface';
import { RowSortingSignature } from '../../interfaces/components/models-table/themes/default/row-sorting-signature.interface';
import { RowSortingCellSignature } from '../../interfaces/components/models-table/themes/default/row-sorting-cell-signature.interface';
import { SelectSignature } from '../../interfaces/components/models-table/themes/default/select-signature.interface';
import { SummarySignature } from '../../interfaces/components/models-table/themes/default/summary-signature.interface';
import { TableSignature } from '../../interfaces/components/models-table/themes/default/table-signature.interface';
import { TableBodySignature } from '../../interfaces/components/models-table/themes/default/table-body-signature.interface';
import { TableFooterSignature } from '../../interfaces/components/models-table/themes/default/table-footer-signature.interface';
import { TableHeaderSignature } from '../../interfaces/components/models-table/themes/default/table-header-signature.interface';
import { IconSignature } from '../../interfaces/components/models-table/themes/default/icon-signature.interface';
/**
 * Almost empty skeleton for themes. Extend it to provide custom CSS-classes for table items and icons.
 *
 * * Every property with suffix `Component` is a path to the component used in theme
 * * Every property with suffix `Msg` is a message shown in the table
 * * Every property with suffix `Icon` is a CSS-class for font-library used as an icons (used for buttons, carets etc)
 */
export default class DefaultTheme extends Service {
    /**
     * @default 'models-table/themes/default/cell'
     */
    get cellComponent(): ComponentLike<CellSignature>;
    /**
     * @default 'models-table/themes/default/cell-content-display'
     */
    get cellContentDisplayComponent(): ComponentLike<CellContentDisplaySignature>;
    /**
     * @default 'models-table/themes/default/cell-content-edit'
     */
    get cellContentEditComponent(): ComponentLike<CellContentEditSignature>;
    /**
     * @default 'models-table/themes/default/cell-edit-toggle'
     */
    get cellEditToggleComponent(): ComponentLike<CellEditToggleSignature>;
    /**
     * @default 'models-table/themes/default/cell-column-summary'
     */
    get cellContentSummaryComponent(): ComponentLike<CellColumnSummarySignature>;
    /**
     * @default 'models-table/themes/default/columns-dropdown'
     */
    get columnsDropdownComponent(): ComponentLike<ColumnsDropdownSignature>;
    /**
     * @default 'models-table/themes/default/columns-hidden'
     */
    get columnsHiddenComponent(): ComponentLike<ColumnsHiddenSignature>;
    /**
     * @default 'models-table/themes/default/data-group-by-select'
     */
    get dataGroupBySelectComponent(): ComponentLike<DataGroupBySelectSignature>;
    /**
     * @default 'models-table/themes/default/expand-all-toggle'
     */
    get expandAllToggleComponent(): ComponentLike<ExpandAllToggleSignature>;
    /**
     * @default 'models-table/themes/default/expand-toggle'
     */
    get expandToggleComponent(): ComponentLike<ExpandToggleSignature>;
    /**
     * @default 'models-table/themes/default/footer'
     */
    get footerComponent(): ComponentLike<FooterSignature>;
    /**
     * @default 'models-table/themes/default/global-filter'
     */
    get globalFilterComponent(): ComponentLike<GlobalFilterSignature>;
    /**
     * @default 'models-table/themes/default/grouped-header'
     */
    get groupedHeaderComponent(): ComponentLike<GroupedHeaderSignature>;
    /**
     * @default 'models-table/themes/default/no-data'
     */
    get noDataComponent(): ComponentLike<NoDataSignature>;
    /**
     * @default 'models-table/themes/default/page-size-select'
     */
    get pageSizeSelectComponent(): ComponentLike<PageSizeSelectSignature>;
    /**
     * @default 'models-table/themes/default/pagination-numeric'
     */
    get paginationNumericComponent(): ComponentLike<PaginationNumericSignature>;
    /**
     * @default 'models-table/themes/default/pagination-simple'
     */
    get paginationSimpleComponent(): ComponentLike<PaginationSimpleSignature>;
    /**
     * @default 'models-table/themes/default/row'
     */
    get rowComponent(): ComponentLike<RowSignature>;
    /**
     * @default 'models-table/themes/default/row-expand'
     */
    get rowExpandComponent(): ComponentLike<RowExpandSignature>;
    /**
     * @default 'models-table/themes/default/row-filtering'
     */
    get rowFilteringComponent(): ComponentLike<RowFilteringSignature>;
    /**
     * @default 'models-table/themes/default/row-filtering-cell'
     */
    get rowFilteringCellComponent(): ComponentLike<RowFilteringCellSignature>;
    /**
     * @default 'models-table/themes/default/row-grouping'
     */
    get rowGroupingComponent(): ComponentLike<RowGroupingSignature>;
    /**
     * @default 'models-table/themes/default/row-group-toggle'
     */
    get rowGroupToggleComponent(): ComponentLike<RowGroupToggleSignature>;
    /**
     * @default 'models-table/themes/default/row-select-all-checkbox'
     */
    get rowSelectAllCheckboxComponent(): ComponentLike<RowSelectAllCheckboxSignature>;
    /**
     * @default 'models-table/themes/default/row-select-checkbox'
     */
    get rowSelectCheckboxComponent(): ComponentLike<RowSelectCheckboxSignature>;
    /**
     * @default 'models-table/themes/default/row-sorting'
     */
    get rowSortingComponent(): ComponentLike<RowSortingSignature>;
    /**
     * @default 'models-table/themes/default/row-sorting-cell'
     */
    get rowSortingCellComponent(): ComponentLike<RowSortingCellSignature>;
    /**
     * @default 'models-table/themes/default/select'
     */
    get selectComponent(): ComponentLike<SelectSignature>;
    /**
     * @default 'models-table/themes/default/summary'
     */
    get summaryComponent(): ComponentLike<SummarySignature>;
    /**
     * @default 'models-table/themes/default/table'
     */
    get tableComponent(): ComponentLike<TableSignature>;
    /**
     * @default 'models-table/themes/default/table-body'
     */
    get tableBodyComponent(): ComponentLike<TableBodySignature>;
    /**
     * @default 'models-table/themes/default/table-footer'
     */
    get tableFooterComponent(): ComponentLike<TableFooterSignature>;
    /**
     * @default 'models-table/themes/default/table-header'
     */
    get tableHeaderComponent(): ComponentLike<TableHeaderSignature>;
    /**
     * @default 'models-table/themes/default/icons/sort-asc'
     */
    get sortAscIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/sort-desc'
     */
    get sortDescIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/clear-filter'
     */
    get clearFilterIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/clear-all-filters'
     */
    get clearAllFiltersIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/column-visible'
     */
    get columnVisibleIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/column-hidden'
     */
    get columnHiddenIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/nav-first'
     */
    get navFirstIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/nav-last'
     */
    get navLastIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/nav-prev'
     */
    get navPrevIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/nav-next'
     */
    get navNextIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/caret'
     */
    get caretIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/select-all-rows'
     */
    get selectAllRowsIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/deselect-all-rows'
     */
    get deselectAllRowsIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/select-some-rows'
     */
    get selectSomeRowsIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/select-row'
     */
    get selectRowIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/deselect-row'
     */
    get deselectRowIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/expand-row'
     */
    get expandRowIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/collapse-row'
     */
    get collapseRowIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/expand-all-rows'
     */
    get expandAllRowsIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default 'models-table/themes/default/icons/collapse-all-rows'
     */
    get collapseAllRowsIconComponent(): ComponentLike<IconSignature>;
    /**
     * @default ''
     */
    cellContentTagName: string;
    /**
     * Label for global filter
     */
    searchLabelMsg: string;
    /**
     * Placeholder for global filter
     */
    searchPlaceholderMsg: string;
    /**
     * Label for dropdown with columns for rows grouping
     */
    groupByLabelMsg: string;
    /**
     * Text on toggle for columns dropdown
     */
    columnsTitleMsg: string;
    /**
     * Label for button to show all table columns (under columns dropdown)
     */
    columnsShowAllMsg: string;
    /**
     * Label for button to hide all table columns (under columns dropdown)
     */
    columnsHideAllMsg: string;
    /**
     * Label for button to restore default visibility for table columns (under columns dropdown)
     */
    columnsRestoreDefaultsMsg: string;
    /**
     * Message shown in the table summary. It's used with three options:
     *
     * 1. First row's index
     * 2. Last row's index
     * 3. Overall rows count
     */
    tableSummaryMsg: string;
    /**
     * Message shown when all columns are hidden. It's shown inside table body
     */
    allColumnsAreHiddenMsg: string;
    /**
     * Message shown when there are not data to display in the table. It's shown inside table body in cases when initial `data` is empty or when all records are filtered out
     */
    noDataToShowMsg: string;
    /**
     * Default label for button "Edit" inside the `cell-edit-toggle`-component
     */
    editRowButtonLabelMsg: string;
    /**
     * Default label for button "Save" inside the `cell-edit-toggle`-component
     */
    saveRowButtonLabelMsg: string;
    /**
     * Default label for button "Cancel" inside the `cell-edit-toggle`-component
     */
    cancelRowButtonLabelMsg: string;
    /**
     * Label for dropdown with page numbers. Used in both numeric and simple pagination
     */
    currentPageNumberMsg: string;
    /**
     * Label for dropdown with rows count shown in the page
     */
    rowsCountMsg: string;
    /**
     * Label for "First"-page in the numeric pagination. It's used for screen-readers and not "visible" by default
     */
    goToFirstPageButtonTextMsg: string;
    /**
     * Label for "Previous"-page in the numeric pagination. It's used for screen-readers and not "visible" by default
     */
    goToPrevPageButtonTextMsg: string;
    /**
     * Label for "Next"-page in the numeric pagination. It's used for screen-readers and not "visible" by default
     */
    goToNextPageButtonTextMsg: string;
    /**
     * Label for "Last"-page in the numeric pagination. It's used for screen-readers and not "visible" by default
     */
    goToLastPageButtonTextMsg: string;
    /**
     * Label for "Clear global filter"-button. It's used for screen-readers and not "visible" by default
     */
    clearGlobalFilterMsg: string;
    /**
     * Label for "Clear filter"-buttons in the table header's cells. It's used for screen-readers and not "visible" by default
     */
    clearFilterMsg: string;
    /**
     * Label for "Clear all filters"-button in the table summary section. It's used for screen-readers and not "visible" by default
     */
    clearAllFiltersMsg: string;
    /**
     * CSS-classes for `table`-tag
     */
    table: string;
    buttonsGroup: string;
    /**
     * CSS-classes for `div`-wrapper over components `global-filter`, `data-group-by-select` and `columns-dropdown`
     */
    headerWrapper: string;
    /**
     * CSS-classes for wrapper used inside `global-filter` component
     */
    globalFilterWrapper: string;
    /**
     * CSS-classes for wrapper used inside `columns-dropdown` component
     */
    columnsDropdownWrapper: string;
    columnsDropdownButtonWrapper: string;
    /**
     * CSS-classes for wrapper over list inside `columns-dropdown` component
     */
    columnsDropdown: string;
    /**
     * CSS-classes for divider for list inside `columns-dropdown` components. Divider is placed before single-column items by default
     */
    columnsDropdownDivider: string;
    /**
     * CSS-classes for wrapper inside `data-group-by-select` component
     */
    dataGroupBySelectWrapper: string;
    /**
     * CSS-classes for thead cells
     */
    theadCell: string;
    /**
     * CSS-classes used for thead-cells with columns titles. This class is used only if columns is not sortable
     */
    theadCellNoSorting: string;
    /**
     * CSS-classes used for thead-cells with columns filters. This class is used only if columns is not filterable
     */
    theadCellNoFiltering: string;
    /**
     * CSS-classes for selected rows. Used in the `row` component
     */
    selectedRow: string;
    /**
     * CSS-classes for expanded rows. Used in the `row` component
     */
    expandedRow: string;
    /**
     * CSS-classes for wrapper inside `footer` component
     */
    tfooterInternalWrapper: string;
    /**
     * CSS-classes for table summary block. Used in the `summary` component
     */
    footerSummary: string;
    /**
     * CSS-classes for table summary block. It's used when table has numeric pagination
     */
    footerSummaryNumericPagination: string;
    /**
     * CSS-classes for table summary block. It's used when table has simple pagination
     */
    footerSummaryDefaultPagination: string;
    /**
     * CSS-classes for wrapper over "Page size"-block in the `footer` component
     */
    pageSizeWrapper: string;
    pageSizeSelectWrapper: string;
    /**
     * Wrapper for select-tag in the current-page-number-select component
     */
    currentPageSizeSelectWrapper: string;
    /**
     * CSS-classes for `pagination-simple` and `pagination-numeric` components
     */
    paginationWrapper: string;
    /**
     * CSS-classes for buttons-wrapper in the `pagination-simple` and `pagination-numeric` components
     */
    paginationInternalWrapper: string;
    /**
     * CSS-classes for `pagination-numeric` component
     */
    paginationWrapperNumeric: string;
    /**
     * CSS-classes for `pagination-simple` component
     */
    paginationWrapperDefault: string;
    paginationBlock: string;
    /**
     * CSS-classes for items in the `pagination-numeric` component
     */
    paginationNumericItem: string;
    /**
     * CSS-classes for active item in the `pagination-numeric` component
     */
    paginationNumericItemActive: string;
    /**
     * CSS-classes for "default" buttons
     */
    buttonDefault: string;
    /**
     * CSS-classes for "link"-buttons
     */
    buttonLink: string;
    /**
     * CSS-classes for `td` shown when all columns are hidden
     */
    noDataCell: string;
    collapseRow: string;
    collapseAllRows: string;
    expandRow: string;
    expandAllRows: string;
    cellContentDisplay: string;
    cellContentEdit: string;
    /**
     * CSS-classes for `thead`
     */
    thead: string;
    /**
     * CSS-classes for `form`
     */
    form: string;
    /**
     * CSS-classes for wrapper over the form elements
     */
    formElementWrapper: string;
    /**
     * CSS-classes for input elements
     */
    input: string;
    /**
     * CSS-classes for `select`
     */
    select: string;
    /**
     * CSS-classes for "Clear filter" button. Used for global filter and filters for each column
     */
    clearFilterIcon: string;
    /**
     * CSS-classes for "Clear all filters" button inside the `summary` component
     */
    clearAllFiltersIcon: string;
    globalFilterDropdownWrapper: string;
    /**
     * CSS-classes for `select` inside the `data-group-by-select` component
     */
    changeGroupByField: string;
    /**
     * CSS-classes for "sort asc/desc" button inside the `data-group-by-select` component
     */
    sortGroupedPropertyBtn: string;
    /**
     * CSS-class for `row-grouping` component
     */
    groupingRow: string;
    /**
     * CSS-classes for `td` inside `row-grouping` component
     */
    groupingCell: string;
    /**
     * CSS-classes for icons used to show that some "list" is sorted "ASC". It's used for `data-group-by-select` and `row-sorting-cell`
     */
    sortAscIcon: string;
    /**
     * CSS-classes for icons used to show that some "list" is sorted "desc". It's used for `data-group-by-select` and `row-sorting-cell`
     */
    sortDescIcon: string;
    /**
     * CSS-classes for icons in the `columns-dropdown` related to the visible columns
     */
    columnVisibleIcon: string;
    /**
     * CSS-classes for icons in the `columns-dropdown` related to the hidden columns
     */
    columnHiddenIcon: string;
    /**
     * CSS-classes for icon used in the "First"-button (`pagination-simple`)
     */
    navFirstIcon: string;
    /**
     * CSS-classes for icon used in the "Prev"-button (`pagination-simple`)
     */
    navPrevIcon: string;
    /**
     * CSS-classes for icon used in the "Next"-button (`pagination-simple`)
     */
    navNextIcon: string;
    /**
     * CSS-classes for icon used in the "Last"-button (`pagination-simple`)
     */
    navLastIcon: string;
    /**
     * CSS-classes for "caret"-icon used in the `columns-dropdown`
     */
    caretIcon: string;
    selectAllRowsIcon: string;
    deselectAllRowsIcon: string;
    selectSomeRowsIcon: string;
    selectRowIcon: string;
    deselectRowIcon: string;
    editRowButton: string;
    saveRowButton: string;
    cancelRowButton: string;
    filteringCellInternalWrapper: string;
    expandRowIcon: string;
    collapseRowIcon: string;
    collapseAllRowsIcon: string;
    expandAllRowsIcon: string;
    get buttonDefaultSmall(): string;
    inputGroup: string;
    [key: string]: any;
}
declare module '@ember/service' {
    interface Registry {
        'emt-themes/default': DefaultTheme;
    }
}
//# sourceMappingURL=default.d.ts.map