import { ComponentLike } from '@glint/template';
import DefaultTheme from './default';
import { ColumnsDropdownSignature } from '../../interfaces/components/models-table/themes/default/columns-dropdown-signature.interface';
import { DataGroupBySelectSignature } from '../../interfaces/components/models-table/themes/default/data-group-by-select-signature.interface';
import { GlobalFilterSignature } from '../../interfaces/components/models-table/themes/default/global-filter-signature.interface';
import { RowFilteringCellSignature } from '../../interfaces/components/models-table/themes/default/row-filtering-cell-signature.interface';
import { SummarySignature } from '../../interfaces/components/models-table/themes/default/summary-signature.interface';
import { PageSizeSelectSignature } from '../../interfaces/components/models-table/themes/default/page-size-select-signature.interface';
import { PaginationSimpleSignature } from '../../interfaces/components/models-table/themes/default/pagination-simple-signature.interface';
import { PaginationNumericSignature } from '../../interfaces/components/models-table/themes/default/pagination-numeric-signature.interface';
export default class EmberBootstrap5Theme extends DefaultTheme {
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/columns-dropdown'
     */
    get columnsDropdownComponent(): ComponentLike<ColumnsDropdownSignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/data-group-by-select'
     */
    get dataGroupBySelectComponent(): ComponentLike<DataGroupBySelectSignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/global-filter'
     */
    get globalFilterComponent(): ComponentLike<GlobalFilterSignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/row-filtering-cell'
     */
    get rowFilteringCellComponent(): ComponentLike<RowFilteringCellSignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/summary'
     */
    get summaryComponent(): ComponentLike<SummarySignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/page-size-select'
     */
    get pageSizeSelectComponent(): ComponentLike<PageSizeSelectSignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/pagination-simple'
     */
    get paginationSimpleComponent(): ComponentLike<PaginationSimpleSignature>;
    /**
     * @default 'models-table/themes/ember-bootstrap-v5/pagination-numeric'
     */
    get paginationNumericComponent(): ComponentLike<PaginationNumericSignature>;
    table: string;
    globalFilterWrapper: string;
    columnsDropdown: string;
    columnsDropdownWrapper: string;
    columnsDropdownDivider: string;
    buttonLink: string;
    buttonDefault: string;
    get buttonDefaultSmall(): string;
    footerSummaryNumericPagination: string;
    footerSummaryDefaultPagination: string;
    pageSizeWrapper: string;
    pageSizeSelectWrapper: string;
    paginationBlock: string;
    paginationWrapperNumeric: string;
    paginationWrapperDefault: string;
    clearFilterIcon: string;
    clearAllFiltersIcon: string;
    sortGroupedPropertyBtn: string;
    tfooterInternalWrapper: string;
    input: string;
    inputGroup: string;
    form: string;
    formElementWrapper: string;
    paginationNumericItemActive: string;
    sortAscIcon: string;
    sortDescIcon: string;
    columnVisibleIcon: string;
    columnHiddenIcon: string;
    navFirstIcon: string;
    navPrevIcon: string;
    navNextIcon: string;
    navLastIcon: string;
    caretIcon: string;
    expandRowIcon: string;
    expandAllRowsIcon: string;
    collapseRowIcon: string;
    collapseAllRowsIcon: string;
    selectAllRowsIcon: string;
    deselectAllRowsIcon: string;
    selectSomeRowsIcon: string;
    selectRowIcon: string;
    deselectRowIcon: string;
}
declare module '@ember/service' {
    interface Registry {
        'emt-themes/ember-bootstrap-v5': EmberBootstrap5Theme;
    }
}
//# sourceMappingURL=ember-bootstrap-v5.d.ts.map